<template>
  <div class="as-control__overlay">
    <div class="as-control">
      <div class="as-control__header">
        <ControlItem
          :controlName="!freezeCards ? 'Freeze card' : 'Unfreeze card'"
          icon="freeze-card"
          @click="freezeCard"
        />
        <ControlItem controlName="Set spend limit" icon="spend-limit" />
        <ControlItem controlName="Add to GPay" icon="gpay" />
        <ControlItem controlName="Replace card" icon="replace-card" />
        <ControlItem
          controlName="Cancel card"
          icon="directive-card"
          @click="deactiveCard"
        />
      </div>
      <div class="as-control__detail">
        <CardDetail />
      </div>
    </div>
    <ConfirmDialog
      :showConfirm="showConfirm"
      @confirm="onConfirm"
      @close-dialog="closeDialog"
    />
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex';
import ConfirmDialog from '@/components/ConfirmDialog';
import ControlItem from './ControlItem';
import CardDetail from './CardDetail';

export default {
  name: 'AsControlCard',
  components: {
    ControlItem,
    CardDetail,
    ConfirmDialog,
  },
  computed: {
    ...mapGetters('card', ['freezeCards']),
  },
  data: () => {
    return {
      showConfirm: false,
    };
  },
  methods: {
    ...mapActions('card', ['deleteCard', 'setFreezeCards']),
    getCurrentSlideId() {
      const slide = document.querySelector(
        '.carousel__slide.carousel__slide--active',
      );
      return slide.attributes['data-id'].value;
    },
    freezeCard() {
      this.setFreezeCards(!this.freezeCards);
    },
    deactiveCard() {
      this.showConfirm = true;
    },
    closeDialog() {
      this.showConfirm = false;
    },
    onConfirm() {
      const id = this.getCurrentSlideId();
      console.log(id);
      this.deleteCard(id);
      this.showConfirm = false;
    },
  },
};
</script>

<style lang="scss">
.as-control {
  width: 100%;
  margin-top: 485px;
  margin-bottom: 56px;
  flex: 1;
  z-index: 3;
  &__header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    height: 116px;
    padding: 0 20px;
    background-color: $-gray;
    border-top-left-radius: 24px;
    border-top-right-radius: 24px;
  }
  &__detail {
    background-color: $-white;
    padding: 20px;
  }
  &__overlay {
    width: 100%;
    height: 100%;
    background-color: transparent;
    display: flex;
    flex-direction: column;
    z-index: 2;
    overflow: auto;
  }
}
</style>
